#!/usr/bin/env python
# -*- coding: utf-8 -*-
from sys import version_info
if version_info[0] != 3:
    print("This script requires Python 3")
    exit()

from os.path import basename
from smtplib import SMTP_SSL
from getpass import getpass
from email.message import EmailMessage
from email.policy import EmailPolicy
from email.utils import formatdate
from configparser import ConfigParser
import csv, logging
import mimetypes

mimetypes.init()
mimetypes.add_type('application/pdf','.pdf')
def autotype(path, default='application/pdf'):
    return (mimetypes.guess_type(path) or (default,))[0].split('/')

with open('mailing.txt') as f:
    sujet=f.readline().strip()
    texte=f.read(-1)

conf=ConfigParser()
conf.read('mailing.conf')
if 'port' not in conf['server']:
    conf['server']['port']='465'
if 'passwd' not in conf['server']:
   conf['server']['passwd']=getpass()
if 'bcc' not in conf['mail']:
   conf['mail']['bcc']='false'
if 'dsn' not in conf['mail']:
   conf['mail']['dsn']='false'

def envoie(serveur,port,login,mdp,sujet,corps,emet,dest,dobcc,file_path,filename=None):
    if filename is None or filename=='':
        filename=basename(file_path)
    msg=EmailMessage(EmailPolicy(utf8=False,cte_type='7bit'))
    msg['Subject']=sujet
    msg['From']=emet
    msg['To']=dest
    msg['Date']=formatdate(localtime=True)
    if dobcc:
        msg['Bcc']=emet
    msg.set_content(corps)
    with open(file_path,'rb') as f:
        dafile=f.read(-1)
    ftype=autotype(file_path)
    msg.add_attachment(dafile, maintype=ftype[0], subtype=ftype[1], filename=filename)
    with SMTP_SSL(serveur,port) as server:
        server.login(login,mdp)
        try:
            if conf['mail']['dsn']=='true' and server.has_extn('DSN'):
                server.send_message(msg,rcpt_options=['NOTIFY=SUCCESS,DELAY,FAILURE'])
            else:
                server.send_message(msg)
            logging.info('{} <- {}: OK'.format(dest,file_path))
        except Exception as e:
            logging.error('{} <- {}: {}'.format(dest,file_path,str(e)))
            print('ERROR ON {}'.format(dest))

logging.basicConfig(filename='mailing.log',level=logging.DEBUG,format='%(asctime)s %(message)s')
logging.info('==== Début du mailing ====')
with open('mailing.csv',newline='') as f:
    reader=csv.reader(f)
    for row in reader:
        print('{} <- {}...'.format(row[0],row[1]))
        envoie(conf['server']['hostname'],int(conf['server']['port']),conf['server']['login'],conf['server']['passwd'],
               sujet,texte.format(*row[3:]),conf['mail']['sender'],row[0],conf['mail']['bcc']=='true',row[1],row[2])
logging.info('==== Fin du mailing ====')
